Rem dialog box variable declare statements.

' Dialog flag constants (use + or OR to use more than 1 flag value)
Const OFN_ALLOWMULTISELECT = &H200& '  Allows the user to select more than one file, not recommended!
Const OFN_CREATEPROMPT = &H2000& '     Prompts if a file not found should be created(GetOpenFileName only).
Const OFN_EXTENSIONDIFFERENT = &H400& 'Allows user to specify file extension other than default extension.
Const OFN_FILEMUSTEXIST = &H1000& '    Chechs File name exists(GetOpenFileName only).
Const OFN_HIDEREADONLY = &H4& '        Hides read-only checkbox(GetOpenFileName only)
Const OFN_NOCHANGEDIR = &H8& '         Restores the current directory to original value if user changed
Const OFN_NODEREFERENCELINKS = &H100000& 'Returns path and file name of selected shortcut(.LNK) file instead of file referenced.
Const OFN_NONETWORKBUTTON = &H20000& ' Hides and disables the Network button.
Const OFN_NOREADONLYRETURN = &H8000& ' Prevents selection of read-only files, or files in read-only subdirectory.
Const OFN_NOVALIDATE = &H100& '        Allows invalid file name characters.
Const OFN_OVERWRITEPROMPT = &H2& '     Prompts if file already exists(GetSaveFileName only)
Const OFN_PATHMUSTEXIST = &H800& '     Checks Path name exists (set with OFN_FILEMUSTEXIST).
Const OFN_READONLY = &H1& '            Checks read-only checkbox. Returns if checkbox is checked
Const OFN_SHAREAWARE = &H4000& '       Ignores sharing violations in networking
Const OFN_SHOWHELP = &H10& '           Shows the help button (useless!)

Type FILEDIALOGTYPE
   $If 32BIT Then
      lStructSize As Long '        For the DLL call
      hwndOwner As Long '          Dialog will hide behind window when not set correctly
      hInstance As Long '          Handle to a module that contains a dialog box template.
      lpstrFilter As _Offset '     Pointer of the string of file filters
      lpstrCustFilter As _Offset
      nMaxCustFilter As Long
      nFilterIndex As Long '       One based starting filter index to use when dialog is called
      lpstrFile As _Offset '       String full of 0's for the selected file name
      nMaxFile As Long '           Maximum length of the string stuffed with 0's minus 1
      lpstrFileTitle As _Offset '  Same as lpstrFile
      nMaxFileTitle As Long '      Same as nMaxFile
      lpstrInitialDir As _Offset ' Starting directory
      lpstrTitle As _Offset '      Dialog title
      flags As Long '              Dialog flags
      nFileOffset As Integer '     Zero-based offset from path beginning to file name string pointed to by lpstrFile
      nFileExtension As Integer '  Zero-based offset from path beginning to file extension string pointed to by lpstrFile.
      lpstrDefExt As _Offset '     Default/selected file extension
      lCustData As Long
      lpfnHook As Long
      lpTemplateName As _Offset
   $Else
      lStructSize AS _OFFSET '        For the DLL call
      hwndOwner AS _OFFSET '          Dialog will hide behind window when not set correctly
      hInstance AS _OFFSET '          Handle to a module that contains a dialog box template.
      lpstrFilter AS _OFFSET '        Pointer of the string of file filters
      lpstrCustFilter AS LONG
      nMaxCustFilter AS LONG
      nFilterIndex AS _INTEGER64 '    One based starting filter index to use when dialog is called
      lpstrFile AS _OFFSET '          String full of 0's for the selected file name
      nMaxFile AS _OFFSET '           Maximum length of the string stuffed with 0's minus 1
      lpstrFileTitle AS _OFFSET '     Same as lpstrFile
      nMaxFileTitle AS _OFFSET '      Same as nMaxFile
      lpstrInitialDir AS _OFFSET '    Starting directory
      lpstrTitle AS _OFFSET '         Dialog title
      flags AS _INTEGER64 '           Dialog flags
      nFileOffset AS _INTEGER64 '     Zero-based offset from path beginning to file name string pointed to by lpstrFile
      nFileExtension AS _INTEGER64 '  Zero-based offset from path beginning to file extension string pointed to by lpstrFile.
      lpstrDefExt AS _OFFSET '        Default/selected file extension
      lCustData AS _INTEGER64
      lpfnHook AS _INTEGER64
      lpTemplateName AS _OFFSET
   $End If
End Type

Declare Dynamic Library "comdlg32" ' Library declarations using _OFFSET types
   Function GetOpenFileNameA&& (DIALOGPARAMS As FILEDIALOGTYPE) ' The Open file dialog
   Function GetSaveFileNameA&& (DIALOGPARAMS As FILEDIALOGTYPE) ' The Save file dialog
End Declare

Declare Library
   Function FindWindow~&& (ByVal ClassName As _Offset, WindowName$) ' To get hWnd handle
End Declare

Dim Shared hWnd As _Integer64

$If 64BIT Then
      hWnd = _WINDOWHANDLE ' FindWindow(0, "Open and Save Dialog" + CHR$(0)) 'get window handle using _TITLE string
$Else
   hWnd&& = FindWindow(0, "HEXEDIT" + Chr$(0)) 'get window handle using _TITLE string
$End If

Dim Shared Title As String * 260

